/*
The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

Alternatively, the contents of this file may be used under the
terms of the GNU General Public License Version 2 or later (the
"GPL"), in which case the provisions of the GPL are applicable 
instead of those above. 

Copyright (C) 2003
Vasa Maximov
mcv@mozdev.org
vmaximov@strana.ru
*/

var helpstr = "In general, this plugin operates on the parameters of the webpage you are curriently browsing and predefined parameters in ConQuery Config Dialog. When you execute ConQuery menu entry, the engine substitutes user variables in predefined URL template with corresponding page data. Available variables are: \n [:selection] - selected text;\n [:url] - page URL;\n [:host] - only HOST from page URL;\n [:prompt] - prompt for input text.\n You may combine variables in template. If there is [:selection] and no selected text on a page, the ConQuery will ask you to input one.\n    All queries organized in two groups: \n - list in ''ConQuery Config'' dialog under the My ConQueries tab;\n - entries under the ''Query to...'' context menu item.\n You may execute queries from bouth places. All manipulations with entries in Config menu performs with mouse right-click. The property ''Show?'' indicates whether query is shown in context menu group.\n The Config Dialog is also accessible via doubleclick on ''Query to...'' context menu entry.\n Note that this is alpha version, so any suggestions will be appreciated.\n Happy serfing!\n McV.";
var EntryList;
var EntryDesc;
var repEntryList;
var delim = "\\";
var ShowAlternatives = false;
var NeedText=false;
var cancel = false;

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  repEntryList = document.getElementById('repEntryList');
	repEntryDesc = document.getElementById('repDesc');
	PlugsDirBox  = document.getElementById('plugsdir');
	ReadOnlyCqr  = document.getElementById('cqonly');
	PlugsDirBox.value = GetMycroftDir();
	document.getElementById('help').value = helpstr;
	FetchPrefs(EntryHash, "Entries.");
	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  initList(EntryList, EntryHash);
}

function initList(list, srcHash){
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();

  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "16");
  listcol2.setAttribute("flex", "1");
  listcol2.setAttribute("style", "width: 4em;");
  listcols.appendChild(listcol1);
    if (srcHash == EntryHash){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
    }
  listheader1.setAttribute('label', "Queries");
  listheader2.setAttribute('label', "Show?");
  listhead.appendChild(listheader1);
    if (srcHash == EntryHash){
      listhead.appendChild(listheader2);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i=0; i<entries.length; i++){
			  if (list.id == "EntryList"){
			  	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery(event.ctrlKey, "'+entries[i].eId+'");';
			  	onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'
			  } else if(list.id == "repEntryList"){
			  	ondk='if (isValidLeftClick(event,"listcell")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
			  	onsel = 'onSelect(repEntryHash, repEntryDesc, '+entries[i].eId+')';
			  }

    item = document.createElement('listitem');
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash == EntryHash){
      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      cellcheck.appendChild(check);
      item.appendChild(cellcheck);
    }
    list.appendChild(item);
  }
}

function FetchPrefs(){
try{
  EntryHash._Clear();
  var entries = new Object();
  //var entry = new ProtoEntry();
  var prfs = Prefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
      entries[tmp[1]] = "";
    }
  for (it in entries){
    entry = new ProtoEntry();
    entry.eId = ReadPref("Entries."+it+".eId");
    entry.Title = ReadPref("Entries."+it+".Title");
    entry.URL = ReadPref("Entries."+it+".URL");
    entry.Method = ReadPref("Entries."+it+".Method");
    entry.Desc = ReadPref("Entries."+it+".Desc");
    entry.Context = ReadPref("Entries."+it+".Context");
    entry.haslist = ReadPref("Entries."+it+".haslist");
    entry.filepath = ReadPref("Entries."+it+".filepath");
    EntryHash._AddEntryObj(entry, entry.eId);
  }
}catch(er){cqerr(er, "FetchPrefs sub")}

}


function FetchPrefs_new(trgHash, group){
  EntryHash._Clear();
  var item = new ProtoEntry();
  var arr = [];
  var entries = new Object;
  var prfs = Prefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      tmp = prfs[p].split(".");
   		entries[tmp[1]] = "";
    }
  for (it in entries){
    a = ReadPref("Entries."+it+".filepath");
    item = ReadPluginData(ReadPref("Entries."+it+".filepath"));
    item.eId = it;
    item.Context = ReadPref("Entries."+it+".Context");
    EntryHash._AddEntryObj(item, "");
    //show(item.Title);
  }
}

function FetchPrefs2(){
  EntryHash._Clear();
  var item = new ProtoEntry();
  var arr = [];
  var entries = new Object;
  var prfs = Prefs.getChildList("Entries.", {value: 0});
    for (p in prfs){
      show(prfs[p]+" = "+ReadPref(prfs[p])+"|");
      tmp = prfs[p].split(".");
      var ff = new Object();
      for (each in tmp) {
   		  if (!ff[each]) ff[each] = new Object();
   		  ff[each] = "";
   		  path = "";
   		  
   		  entries[tmp[1]] = "";
   	  }
    }
//  for (it in entries){
//    a = ReadPref("Entries."+it+".filepath");
//    item = ReadPluginData(ReadPref("Entries."+it+".filepath"));
//    item.eId = it;
//    item.Context = ReadPref("Entries."+it+".Context");
//    EntryHash._AddEntryObj(item, "");
//    //show(item.Title);
//  }
}

function ReadPref(name){
	if (Prefs.prefHasUserValue(name)) {
	var type = Prefs.getPrefType(name);
    if (type & 128) {
      return Prefs.getBoolPref(name);
    }
    else if (type & 32) {
			return Prefs.getCharPref(name);
    }
		else {
			return "";
		}
	}
}

function SavePrefs(){
try{
  Prefs.deleteBranch("Entries.");
  var entries = EntryHash._Items();
  for (e in entries){
    Prefs.setCharPref("Entries."+entries[e].eId+".eId", entries[e].eId);
    Prefs.setCharPref("Entries."+entries[e].eId+".Title", entries[e].Title);
    Prefs.setCharPref("Entries."+entries[e].eId+".URL", entries[e].URL);
    Prefs.setCharPref("Entries."+entries[e].eId+".Method", entries[e].Method);
    Prefs.setCharPref("Entries."+entries[e].eId+".Desc", entries[e].Desc);
    Prefs.setCharPref("Entries."+entries[e].eId+".filepath", entries[e].filepath);
    Prefs.setBoolPref("Entries."+entries[e].eId+".Context", entries[e].Context);
    Prefs.setBoolPref("Entries."+entries[e].eId+".haslist", entries[e].haslist);
    
//    for (i in entries[e].Inputs){
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".priority", entries[e].Inputs[i].priority);
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".grouptitle", entries[e].Inputs[i].grouptitle);
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".label", entries[e].Inputs[i].label);
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".name", entries[e].Inputs[i].name);
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".value", entries[e].Inputs[i].value);
//      Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".priority", entries[e].Inputs[i].priority);
//      if (entries[e].Inputs[i].list){
//        for (v in entries[e].Inputs[i].list){
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".priority", entries[e].Inputs[i].list[v].priority);
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".grouptitle", entries[e].Inputs[i].list[v].grouptitle);
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".label", entries[e].Inputs[i].list[v].label);
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".name", entries[e].Inputs[i].list[v].name);
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".value", entries[e].Inputs[i].list[v].value);
//          Prefs.setCharPref("Entries."+entries[e].eId+".Inputs."+i+".list."+v+".priority", entries[e].Inputs[i].list[v].priority);
//        }
//      }
//    }
	}
}catch(er){cqerr(er, "SavePrefs sub")}
}


function LoadRepository(src){
  if (!src) src = document.getElementById('repsrc').label;
	repEntryHash._Clear();
	try{
		xmlDoc = GetXMLFromWeb(src);
		//pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry")[0].getElementsByTagName("title")[0].firstChild.data;//.nodeName
		pNode = xmlDoc.getElementsByTagName("conquery")[0].getElementsByTagName("entry");
		for (i=0; i<pNode.length; i++){
	    repEntryHash._Add(
	      "",
	      ParseNode(pNode[i], "title"),
	      ParseNode(pNode[i], "url"),
	      ParseNode(pNode[i], "method"),
	      ParseNode(pNode[i], "desc"),
	      ""
	    )
		}
	}
	catch(er){cqerr(er, "LoadRepository sub")}
	//initList(repEntryList, repEntryHash);
	initRepTree(repEntryList, repEntryHash);
}

function ParseNode(node, child){
	try{return node.getElementsByTagName(child)[0].firstChild.data;}
	catch(er){return "";}
}

function GetXMLFromWeb(uri) {
	try{
		var xrequest = new XMLHttpRequest();
		xrequest.open("GET",uri,false);
		xrequest.setRequestHeader('Content-type', 'text/xml');
		xrequest.send(null);
	}catch(er){cqerr(er, "GetXMLFromWeb sub")}
	return xrequest.responseXML;
}

function CopyFromRep(){
try{
  var item = new ProtoEntry();
	var RepId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
 
  //item = repEntryHash._Item(RepId)._Clone();
  //for (each in repEntryHash._Item(RepId)) alert(each);
  EntryHash._AddEntryObj(repEntryHash._Item(RepId), "");
	SavePrefs();
	initList(EntryList, EntryHash);
	alert("''"+repEntryHash._Item(RepId).Title + "'' installed");
}catch(er){cqerr(er, "CopyFromRep sub")}
}

//function CopyFromRep(){
//	var RepId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
//	EntryHash._Add(
//		"",
//		repEntryHash._Item(RepId).Title,
//		repEntryHash._Item(RepId).URL,
//		repEntryHash._Item(RepId).Method,
//		repEntryHash._Item(RepId).Desc,
//		true
//	);
//	SavePrefs();
//	initList(EntryList, EntryHash);
//	alert("''"+repEntryHash._Item(RepId).Title + "'' added to My ConQueries Tab");
//}

function ReadPluginData(filepath){
  var retItem = new ProtoEntry();
  var haslist = false;
  //retItem = new Object;
	filedata = cqReadFile(filepath);
	filedata = filedata.replace(/#.*/ig,"");
	filedata = filedata.replace(/[\n\r\f\t]/ig,"  ");
	SearchTagData = filedata.match(/<search.+?<\/search>)/gi);
	//mcSearch = null;
	mcSearch = GetTagsFromString("search", SearchTagData);
	if (mcSearch[0]){
		var act = "";
		var amp = "";
		retItem.Title = mcSearch[0].name;
		retItem.Action = mcSearch[0].action;
		retItem.Method = mcSearch[0].method;
		retItem.Desc = mcSearch[0].description;
		var inp = GetTagsFromString("input", SearchTagData);
		for (each in inp){
			act += amp+inp[each].name+"="+inp[each].value;
			amp = "&";
			//retItem.Inputs[inp[each].priority] = inp[each];
			haslist = retItem._StoreInput(inp[each]);
      if (!retItem.haslist) retItem.haslist = haslist;
		}
		retItem.URL = mcSearch[0].action+"?"+act;
		if ((!retItem.Title) || (retItem.Title=="undefined")) {
		  retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
		  retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
		}
		if ((!retItem.Method) || (retItem.Method=="undefined")) retItem.Method = "GET";
		if ((!retItem.Desc) || (retItem.Desc=="undefined")) retItem.Desc = "";
		if ((!retItem.URL) || (retItem.Action=="undefined")) retItem.Action = "!!!PARSEERROR!!!";
		retItem.eId = "";
		retItem.filepath = filepath;
		retItem.Context = true;
	}else{
	  	retItem.eId = "";
	  	retItem.Title = "zzzz!!! PARSEERROR: "+filepath;
	  	retItem.URL = "none";
	  	retItem.Method = "GET";
	  	retItem.Desc = filepath + " has no <search> tag or <search> tag not well formed!";
	  	retItem.Context = "";
	  	retItem.FilePath = filepath;
	}
  return retItem;	
}



//function GetTagFromString(tag, str){
//	//This extracts all <tag param=value> patterns from str
//	//WARNING! It sucks on patterns like <tag param="from > to"> extracting only <tag param="from >
//	var lcTagsData = [];
//	var lcTagsBuff = "  ";
//	//var lcTagsRE = new RegExp("<"+tag+" .+?>","i");
//	var lcTagsRE = new RegExp("<"+tag+" .[^<]+?>","i");
//	while (lcTagsBuff){
//	  lcTagsBuff = String(str).match(lcTagsRE);
//	  if (lcTagsBuff){
//			lcTagsData[lcTagsData.length]=ParseTagParams(lcTagsBuff);
//	    str = String(str).replace(lcTagsBuff, "");
//	  }
//	}
//return lcTagsData;
//}
  
function GetTagsFromString(tag, str){
	//This extracts all <tag param=value> patterns from str
	//WARNING! It sucks on patterns like <tag param="from > to"> extracting only <tag param="from >
	var lcTagsData = [];
	var lcTagsBuff = [];
	//var lcTagsRE = new RegExp("<"+tag+" .+?>","i");
	var lcTagsRE = new RegExp("(<"+tag+" .[^<]+?>)","ig");
	while (lcTagsBuff!=null){
	  lcTagsBuff = lcTagsRE.exec(str);
	  if (lcTagsBuff!=null){
			lcTagsData[lcTagsData.length]=ParseTagParams(lcTagsBuff[0]);
			lcTagsData[lcTagsData.length-1].priority = lcTagsRE.lastIndex;
	    for(i=0;i<lcTagsBuff[0].length;i++)spacer+=" ";
	    str = String(str).replace(lcTagsBuff[0], spacer);
	  }
	}
return lcTagsData;
}

function ParseTagParams(tag){
  var lcParams = new Object;
	var lcParamsBuff = "  ";
  var lcParamsData = [];
  //To correct Mycroft's "user" in <input>.
  //To plugin coders:
  //   Guys, please, no <input name="blah" user=""> and unclosed <search> tags!
  //   Read Mycroft spec! Such inputs will have value="!!!PARSEERROR!!!"
  tag = String(tag).replace(/\s+?user(?=\s*[\/>])/i, " value="+String.fromCharCode(34)+"[:selection]"+String.fromCharCode(34));
	lcParams["value"]="!!!PARSEERROR!!!";
  while (lcParamsBuff){
	//This will understand only <"> but not <'> as pattern, sorry :(
		lcParamsBuff = String(tag).match(/\w+\s*?=\s*?".*?"/i);
		if (lcParamsBuff){
			lcParamsArr = String(lcParamsBuff).split(/=\s*"/);
			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/"\s*/, "");
			//show(lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] +">>>>>"+ String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase());
			tag = String(tag).replace(lcParamsBuff, "");
		}
	}
  //for not parenthesized params (i.e. param=value)
  lcParamsBuff = "  ";
  while (lcParamsBuff){
		lcParamsBuff = String(tag).match(/\w+?\s*?=\s*?\w+?(?=[\s\/>])/i);
		if (lcParamsBuff){
			lcParamsArr = String(lcParamsBuff).split(/=/);
			lcParamsArr[1] = lcParamsArr[1].replace(/^\s+/, "");
			lcParams[String(lcParamsArr[0].replace(/\s+/,"")).toLowerCase()] = lcParamsArr[1].replace(/\s+$/, "");
			tag = String(tag).replace(lcParamsBuff, "");
		}
	}
return lcParams;
}

function cqReadFile(filename) {
    var MODE_RDONLY = 0x01;
    var PERM_IRUSR = 00400;
    
    try {
        var file = Components.classes["@mozilla.org/file/local;1"].
                   createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(filename);
        if (file.exists() && file.isReadable()) {
            var is = Components.classes["@mozilla.org/network/file-input-stream;1"].
                     createInstance(Components.interfaces.nsIFileInputStream);
            is.init(file, MODE_RDONLY, PERM_IRUSR, 0);
            var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].
                createInstance(Components.interfaces.nsIScriptableInputStream);
            sis.init(is);
            var data = sis.read(sis.available());
            sis.close();
            is.close();
            return data;
        }
        else {
            cqerr(null, "File" + filename + "read error in cqReadFile\n");
            return null;
        }
    }
    catch (er) {
        cqerr(er, "File" + filename + "read error in cqReadFile\n");
    }
    return null;
}

function initRepTree(list, srcHash){
//window.setTimeout('setstatus("Buidling tree...")',7000);
  var cnt = 0;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  //while (list.hasChildNodes()) {alert(list.lastChild.name)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var entries = srcHash._Items();
	var treecols = document.createElement('treecols');
	var treecol = document.createElement('treecol');
  treecol.setAttribute("label", "Found plugins");
  treecol.setAttribute("flex", "1");
  treecol.setAttribute("id", "www");
	treecols.appendChild(treecol);
	list.appendChild(treecols);
	var tch = document.createElement('treechildren');
	//list.appendChild(tch);

  for (i in entries){
    //window.setTimeout('setstatus("Building tree: '+cnt+' childes so far")',7000);
  	//cnt++;
  	ondk='if (isValidLeftClick(event,"listitem")) CopyEntry(repEntryHash, '+entries[i].eId+', EntryHash, EntryList);';
  	onsel = 'onSelectRep('+entries[i].eId+')';
  	//onsel = 'alert('+entries[i].eId+');';
    item = document.createElement('treeitem');
    item.setAttribute('id', entries[i].eId);
    row = document.createElement('treerow');

    row.setAttribute('id', entries[i].eId);
    //alert(entries[i].eId);
    row.setAttribute('ondblclick', ondk);
    //row.setAttribute('allowevents', true);
		
    celldata = document.createElement('treecell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('onselect', onsel);
    row.appendChild(celldata);
    
    //if (isValidLeftClick(event,"listitem")) 
    item.appendChild(row);
    tch.appendChild(item);
    //list.insertBefore(item, prevItem);
  }
  list.appendChild(tch);
}

function GetMycroftDir(){
	var gDirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
	var gChromeDir      = gDirServiceProp.get("AChrom",Components.interfaces.nsIFile);
	delim = "\\";
	if (gChromeDir.path.substr(0,1)=="/") delim = "/";
	patharr = gChromeDir.path.split(delim);
	patharr[patharr.length-1]="searchplugins";
	return patharr.join(delim);
}


function CopyEntry(srcHash, item, trgHash, trgList){
	trgHash._Add(
		"",
		srcHash._Item(item).Title,
		srcHash._Item(item).URL,
		srcHash._Item(item).Method,
		srcHash._Item(item).Desc,
		true
	);
	SavePrefs();
	initList(trgList, trgHash);
	alert(srcHash._Item(item).Title + " copied");
}

function rmEntry()
{
  if (!EntryList.selectedItem) return;
  EntryHash._Rm(EntryList.selectedItem.getAttribute('value'));
  SavePrefs();
  initList(EntryList, EntryHash);
}

//function onSelect(trgHash, trgDesc, item){
//	trgDesc.value = trgHash._Item(item).Title + ":\n" +
//	trgHash._Item(item).Method + " " + 
//	trgHash._Item(item).URL + "\n" +
//	trgHash._Item(item).Desc;
//}

function onSelect(){
	var desctext = "";
	eId = EntryList.selectedItem.getAttribute('value');
	item = EntryHash._Item(eId);
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	if (item.haslist) desctext += "\n\n This query has additional parameters. Hold Ctrl while executing menu entry to configure";
	EntryDesc.value = desctext;
}

function onSelectRep(eId){
	if (!eId) eId = repEntryList.contentView.getItemAtIndex(repEntryList.currentIndex).id;
	item = repEntryHash._Item(eId);
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	desctext += "\n------------------------------------\nQuery has following Inputs:\n";
  for (i in item.Inputs){
    desctext += i+" = "+item.Inputs[i].value +"\n";
    if (item.Inputs[i].list){
    	for (v in item.Inputs[i].list) desctext += "   or: "+item.Inputs[i].list[v].value + "\n";
    }
  }
  repEntryDesc.value = desctext;
}

function UpdateStatus(check){
  EntryHash[check.id].Context = check.checked;
	SavePrefs();
}

function ImportPlugins(){
	//if (!item) item=EntryList.selectedItem.getAttribute('value');
	//if (item=="add") item="";
	repEntryHash._Clear();
	window.openDialog("chrome://conquery/content/mcparser.xul","_blank",
	"centerscreen,chrome,modal,resizable=yes", document.getElementById("plugtype").selectedItem.id);
}

function AddUpdate(item){
	if (!item) item=EntryList.selectedItem.getAttribute('value');
	if (item=="add") item="";
	window.openDialog("chrome://conquery/content/addupdate.xul","_blank",
	"centerscreen,chrome,modal,resizable=yes", item);
	SavePrefs();
	initList(EntryList, EntryHash);
}

function ExecQuery(ctrl, id){
try{
  window.opener.top.ConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.ConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqerr(er, "ExecQuery sub")}
}

function isValidLeftClick(aEvent, aName)
{
  // && aEvent.originalTarget.localName == aName
  return (aEvent.button == 0);
}

//function onReturnHit(Event)
//{
//  var focusedElement = document.commandDispatcher.focusedElement;
//
//  if (!focusedElement ||
//    (aEvent.keyCode != aEvent.DOM_VK_ENTER &&
//    aEvent.keyCode != aEvent.DOM_VK_RETURN)) return;
//
//  aEvent.preventBubble();
//  if (focusedElement == gURIBox.inputField)
//    gAddButton.doCommand();
//}
//
